<?PHP // $Id: collect.php,v 1.0 2006/03/20 03:45:49 krajewsk Exp $

//  Collect All Posts
//  Collects all of a forum's posts onto one page for easy review.
//  This is similar to the <<cough cough>> Blackboard function of "collect all"
//  Much of this code is from the regular forum view.php

//  A new class, .augsburg .indent { margin-left: 30px; }
//  Is needed in the style sheet to get the indenting to work.  Still figuring this one out.

//  To add to your forum pages add below code (uncommented!) into mod/forum/view.php at about line 191. 
//  It puts a button just below the RSS feed.
//    echo '</tr><tr><td align="right">';
//    echo '<div>';
//    echo "<form name=\"newdiscussionform\" method=\"get\" action=\"$CFG->wwwroot/augsburg/collect.php\">";
//    echo "<input type=\"hidden\" name=\"f\" value=\"$forum->id\" />";
//    echo '<input type="submit" value="';
//    echo 'Collect All '.get_string('posts');
//    echo '" />';
//    echo '</form>';
//    echo "</div>\n";
//    echo '</td>';


    require_once('../config.php');
    require_once('../mod/forum/lib.php');


    $id      = optional_param('id', 0, PARAM_INT);        // Course Module ID
    $f       = optional_param('f', 0, PARAM_INT);         // Forum ID

    if ($id) {
        if (! $cm = get_record("course_modules", "id", $id)) {
            error("Course Module ID was incorrect");
        }
        if (! $course = get_record("course", "id", $cm->course)) {
            error("Course is misconfigured");
        }
        if (! $forum = get_record("forum", "id", $cm->instance)) {
            error("Forum ID was incorrect");
        }

        $strforums = get_string("modulenameplural", "forum");
        $strforum = get_string("modulename", "forum");

        $buttontext = update_module_button($cm->id, $course->id, $strforum);

    } else if ($f) {
        if (! $forum = get_record("forum", "id", $f)) {
            error("Forum ID was incorrect or no longer exists");
        }
        if (! $course = get_record("course", "id", $forum->course)) {
            error("Forum is misconfigured - don't know what course it's from");
        }

        $strforums = get_string("modulenameplural", "forum");
        $strforum = get_string("modulename", "forum");

        if ($cm = get_coursemodule_from_instance("forum", $forum->id, $course->id)) {
            $buttontext = update_module_button($cm->id, $course->id, $strforum);
        } else {
            $cm->id = 0;
            $cm->visible = 1;
            $cm->course = $course->id;
            $buttontext = "";
        }

    } else {
        error("Must specify a course module or a forum ID");
    }


    require_course_login($course, true, $cm);

    add_to_log($course->id, 'collectall', 'view', 'augsburg/collect.php?id='.$id, '');

/// Check to see if groups are being used in this forum
/// Set mygroup.

    $canreply = NULL;   /// No override one way or the other

    if ($forum->type == "teacher") {
        $groupmode = NOGROUPS;
    } else {
        $groupmode = groupmode($course, $cm);
    }

                                       
    
    if ($groupmode and !isteacheredit($course->id)) {   // Groups must be kept separate
        $mygroupid = mygroupid($course->id);

    }



/// Print headers

    $navigation = "<a href=\"$CFG->wwwroot/mod/forum/index.php?id=$course->id\">$strforums</a> -> ";
    $navigation .= "<a href=\"$CFG->wwwroot/mod/forum/view.php?id=$cm->id\">".format_string($forum->name)."</a> -> Collect All Posts";
    print_header_simple(format_string($forum->name), "",
                 $navigation, "", "", true,"" , navmenu($course, $cm));



/// Print settings and things in a table across the top

    $forum->intro = trim($forum->intro);
	echo "<br />";
    if (!empty($forum->intro)) {
	     print_simple_box(format_text($forum->intro), 'center', '70%', '', 5, 'generalbox', 'intro');		
    }

	if ($discussions = get_records("forum_discussions", "forum", $forum->id, "timemodified DESC")) {
    	foreach ($discussions as $discussion) {
    	    // Check group status, display only if in right group
			if ($groupmode == SEPARATEGROUPS) {
                if ((isteacher($course,$USER->id)) || ($mygroupid == $discussion->groupid) || ($discussion->groupid == -1) ) {
                   if (! $post = forum_get_post_full($discussion->firstpost)) {
                   error("Could not find the first post in this forum");
                   }
                 $displaymode = 3;
                 // echo "<h2>".$discussion->name."</h2>";
    		     forum_print_discussion_aug($course, $forum, $discussion, $post, $displaymode);
    		    }
    		} else { // groups don't matter, show them all
    		if (! $post = forum_get_post_full($discussion->firstpost)) {
            error("Could not find the first post in this forum");
            }
    		$displaymode = 3;
    		forum_print_discussion_aug($course, $forum, $discussion, $post, $displaymode);
    		}
    	
    	}
    }

/// Print footer

    print_footer($course);

?>
