<?php
/** push_users.php
 * 
 * This script is meant to be called from a cronjob to sync moodle with the LDAP 
 * backend in those setups where the LDAP backend acts as 'master'.
 * 
 * Recommended cron entry:
 * # 5 minutes past 4am
 * 5 4 * * * /usr/bin/php -c /etc/php4/apache/php.ini /var/www/moodle/augsburg/push_users.php > /var/www/push.out
 *
 * This is a hack of the ldap sync file and it uses the fields for the database authentication plugin
 * 
 * Notes: 
 *   - If you have a large number of users, you may want to raise the memory limits
 *     by passing -d momory_limit=256M
 *   - For debugging & better logging, you are encouraged to use in the command line:
 *     -d log_errors=1 -d error_reporting=E_ALL -d display_errors=0 -d html_errors=0
 *     
 *    
 */


/* if(!empty($_SERVER['GATEWAY_INTERFACE'])){
    error_log("should not be called from apache!");
    exit;
}

*/

require_once(dirname(dirname(__FILE__)).'/config.php'); // global moodle config file.

require_once($CFG->dirroot.'/course/lib.php');
require_once($CFG->dirroot.'/lib/blocklib.php');
require_once($CFG->dirroot.'/mod/resource/lib.php');
require_once($CFG->dirroot.'/auth/ldap/lib.php');
require_once($CFG->dirroot.'/mod/forum/lib.php');


    // connect to external db based on db auth prefs
    ADOLoadCode($CFG->auth_dbtype);          
    $authdb = &ADONewConnection();         
    $authdb->PConnect($CFG->auth_dbhost,$CFG->auth_dbuser,$CFG->auth_dbpass,$CFG->auth_dbname); 

    $userlist = array();  // list of usernames
    $thisfname = '';
    $thislname = '';
    $thisidnumber = '';
    $timenow  = time();
    $starttime = microtime();
	echo "Server Time: ".date('r',$timenow)."\n\n";


   /// loop through the table and get all the usernames
   
    if ($rs = $authdb->Execute("SELECT $CFG->auth_dbfielduser FROM $CFG->auth_dbtable
    							where employeenumber <> '' AND $CFG->auth_dbfielduser <> '' order by $CFG->auth_dbfielduser
                                        ")) {
             if ($rs->RecordCount() > 0) {
                while (!$rs->EOF) {
                    $userlist[] = $rs->fields[0];
                    // echo $rs->fields[0]."\n";
                    $rs->MoveNext();
                }        
        }        
     }

   /// get the basic fields for these users
   
   foreach ($userlist as $user) {
    if ($rs = $authdb -> Execute("SELECT givenname,sn,employeenumber FROM $CFG->auth_dbtable
    							WHERE $CFG->auth_dbfielduser = '$user'")) {
    	 if ($rs->RecordCount() == 1) {
    	 $thisfname = $rs->fields[0];
    	 $thislname = $rs->fields[1];
    	 $thisidnumber = $rs->fields[2];

         /// check to see if they're in moodle already

         $select = "username = '$user' AND deleted = '0'";
         if ($moodleuser = get_records_select('user', $select)){
             echo $user." is already in moodle";
             echo "\n";
             } else {
             echo $user." is not in moodle [";
             
             
             /// create basic user object for insertion
            $insertuser = NULL;
            $insertuser->auth = 'ldap';
            $insertuser->username = $user;
            $insertuser->idnumber = $thisidnumber;
            $insertuser->firstname = addslashes($thisfname);
            $insertuser->lastname = addslashes($thislname);
            $insertuser->email = $user."@augsburg.edu";
            $insertuser->confirmed = 1;
            $insertuser->city= 'Minneapolis';
            $insertuser->trackforums = 1;
            $insertuser->autosubscribe = 0;
            
            if (insert_record('user', $insertuser)) {
                 echo "added successfully";
                 } else {
                 echo "** add failed **";
                 }
             
             
             echo "]\n";
             }
           

    	 }
    							
    	}
   
   }
   
	echo "\n========================================\n";
	echo "End time: ".date('r',$timenow)."\n";
	$difftime = microtime_diff($starttime, microtime());
    echo "Execution took ".$difftime." seconds"; 



?>
